<template>
  <v-menu
    ref="timeMenu"
    :close-on-content-click="false"
    v-model="timeMenu"
    :nudge-right="40"
    :return-value.sync="time"
    transition="scale-transition"
    offset-y
    min-width="290px"
  >
    <template v-slot:activator="{ on }">
      <v-text-field
        v-on="on"
        v-model="time"
        prepend-icon="mdi-calendar"
        readonly
        v-bind="$attrs"
      ></v-text-field>
    </template>
    <v-time-picker
      v-model="time"
      v-bind="$attrs"
      v-if="timeMenu"
      @click:minute="save(time)"
    ></v-time-picker>
  </v-menu>
</template>

<script>
/**
 * Time Input
 * @displayName Time Input
 * @example ../examples/TimeInput.md
 */
export default {
  name: "TimeInput",
  props: {
    value: {
      type: String,
      default: ""
    },
    events: {
      type: Object,
      default: () => ({})
    },
    props: {
      type: Object,
      default: () => ({})
    }
  },
  data() {
    return {
      timeMenu: false,
      time: this.value
    };
  },
  watch: {
    value(v) {
      if (v !== this.time) {
        this.time = v;
      }
    }
  },
  methods: {
    save(value) {
      this.$refs.timeMenu.save(value);
      this.$emit("input", value);
      this.timeMenu = false;
    }
  }
};
</script>
